<template>
    <div class="box__lastTable--element wow fadeInUp">
        <div class="box__element--left">
            <div class="left--left">
                <p class="text-idBlueBold">#{{ user.id }}</p>
                <p class="text-idBlack">{{ user.login }}</p>
            </div>
            <div class="right--right">
                <p class="text-idBlue balans">{{ formattedBalance }}</p>
                <p class="text-idBlack register">{{ formattedRegistration }}</p>
                <p class="text-id vxod">{{ formattedLastLogin }}</p>
                <p class="text-id ip">{{ user.last_login_ip }}</p>
                <p class="text-idEuro country">
                    <svg class="flag-icon">
                        <use :xlink:href="flag"/>
                    </svg>
                    {{ country_code.toUpperCase() }}
                </p>
                <p class="text-idEuro iconRemove status">
                    <svg class="yellow" v-if="user.role > 60">
                        <use xlink:href="/img/sprite.svg#premium"/>
                    </svg>
                    <svg class="blue" v-else-if="user.role > 30">
                        <use xlink:href="/img/sprite.svg#premium"/>
                    </svg>
                    <img src="/img/skill111.png" alt="" class="skill111" v-else>
                </p>
                <p class="text-idOnline status2" :class="{offline: !user.is_online}">
                    {{ user.is_online ? $t('ui.online') : $t('ui.offline') }}
                </p>
            </div>
        </div>
        <div class="box__element--edit">
            <div class="top-white">
                <svg class="delete" @click="deleteUser">
                    <use xlink:href="/img/sprite.svg#cancel-button"/>
                </svg>
                <router-link :to="route('users_edit', {id: user.id})">
                    <svg class="edit">
                        <use xlink:href="/img/sprite.svg#edit"/>
                    </svg>
                </router-link>
                <router-link :to="route('users_auth_log', {id: user.id})">
                    <svg class="key">
                        <use xlink:href="/img/sprite.svg#key"/>
                    </svg>
                </router-link>
                <router-link :to="route('users_referrals', {id: user.id})">
                    <svg class="networking">
                        <use xlink:href="/img/sprite.svg#networking"/>
                    </svg>
                </router-link>
                <a :href="loginUrl">
                    <svg class="world">
                        <use xlink:href="/img/sprite.svg#world"/>
                    </svg>
                </a>
            </div>
            <div class="bottom-blue">
                <svg class="yellow" @click="setRole(99)">
                    <use xlink:href="/img/sprite.svg#premium"/>
                </svg>
                <svg class="blue" @click="setRole(50)">
                    <use xlink:href="/img/sprite.svg#premium"/>
                </svg>
                <img src="/img/skill111.png" alt="" class="skill111"  @click="setRole(0)">
            </div>
        </div>
    </div>
</template>

<script>
    import currencies from './../../currencies';
    import { mapGetters } from 'vuex';
    import route from "../../mixins/route";

	export default {
		name: "User",
        props: ['user'],
        mixins: [route],
        computed: {
		    ...mapGetters([
		        'admin_prefix',
                'axios'
            ]),
            formattedRegistration(){
                return this.$date(this.user.created_at).format('DD.MM.YYYY HH:mm');
            },
            formattedLastLogin(){
                return this.user.last_login_at ? this.$date(this.user.last_login_at).format('DD.MM.YYYY HH:mm') : '-';
            },
            formattedBalance(){
                return currencies.formatWithDefault(this.user.balance, this.user.currency);
            },
            country_code(){
                return this.user.country_code ? this.user.country_code.toLowerCase() : 'eu';
            },
            flag(){
                return `/img/flags.svg#${this.country_code}`;
            },
            loginUrl(){
		        return `/${this.admin_prefix}/users/${this.user.id}/login`
            }
        },
        methods: {
		    deleteUser(){
                this.axios
                    .post(`users/${this.user.id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        if(data && data.status === 'success'){
                            this.$swal('Успешно', 'Удалено');
                            this.$emit('reload');
                        }else{
                            this.$swal(this.$t('ui.error'), `Ошибка при удалении`, 'error');
                        }
                    });
            },
            setRole(role){
                this.axios
                    .post(`users/${this.user.id}/role`, {
                        role: role
                    })
                    .then(resp => resp.data)
                    .then(data => {
                        if(data && data.status === 'success'){
                            this.$swal('Успешно', 'Роль установлена');
                            this.$emit('reload');
                        }else{
                            this.$swal(this.$t('ui.error'), `Ошибка при изменении роли`, 'error');
                        }
                    });
            }
        }
	}
</script>

<style scoped lang="scss">
    .lastPage--lastTable .box__lastTable--element .box__element--left .right--right .text-idEuro{
        justify-content: flex-end;
    }
    .flag-icon {
        display: block;
        max-width: 30px;
        height: 30px;
        margin-right: 5px;
    }
    .box__element--edit{
        .top-white{
            a{
                width: 23px;
                height: 22px;
            }
        }
    }
    .status{
        svg{
            display: block;
            width: 21px;
            height: 21px;
            margin-right: 5px;
        }
        .yellow{
            fill: #ffcd04;
        }
        .blue{
            fill: #97b2ff;
        }
    }

	@media (max-width: 576px) {
		.lastPage--lastTable .box__lastTable--element .box__element--left .right--right .text-idEuro{
			justify-content: center;
		}
	}
</style>
